Index: GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp	(revision 801)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp	(revision 811)
@@ -1155,4 +1155,9 @@
 		 "10");
 
+  RegisterOption("RenderSampler.samples",
+				 optInt,
+				 "render_sampler_samples=",
+				 "1000");
+
   RegisterOption("VssPreprocessor.initialSamples",
 				 optInt,
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 752)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 811)
@@ -191,5 +191,5 @@
 		  parser = new X3dParser;
 		else
-		  if (strstr(filename.c_str(), ".ply"))
+		  if (strstr(filename.c_str(), ".ply") || strstr(filename.c_str(), ".plb"))
 			parser = new PlyParser;
 		  else
Index: GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 746)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 811)
@@ -14,4 +14,5 @@
 #include "SceneGraph.h"
 #include "PreprocessorThread.h"
+#include "RenderSampler.h"
 
 #include <QApplication>
@@ -60,14 +61,17 @@
 		if (preprocessorType == "sampling")
 		  p = new SamplingPreprocessor();
-		else {
-		  cerr<<"Unknown preprocessor type"<<endl;
-		  Debug<<"Unknown preprocessor type"<<endl;
-		  exit(1);
-		}
-
+		else
+		  if (preprocessorType == "render")
+			p = new RenderSampler();
+		  else {
+			cerr<<"Unknown preprocessor type"<<endl;
+			Debug<<"Unknown preprocessor type"<<endl;
+			exit(1);
+		  }
+  
 
   QApplication *app = NULL;
 
-  if (p->mUseGlRenderer) {
+  if (p->mUseGlRenderer || p->mUseGlDebugger) {
 	// create a qt application first (must be created before any opengl widget...
 	app = new QApplication(argc, argv);
@@ -109,11 +113,12 @@
 	rendererWidget->resize(640, 480);
 	rendererWidget->show();
-
+	
 	if (p->GetRenderer()) {
-
+	  
 	  cout<<"CONNECTING"<<endl;
 	  QObject::connect(p->GetRenderer(),
 					   SIGNAL(UpdatePvsErrorItem(int i,
 												 GlRendererBuffer::PvsErrorEntry &)),
+
 					   rendererWidget->mControlWidget,
 					   SLOT(UpdatePvsErrorItem(int i,
Index: GTP/trunk/Lib/Vis/Preprocessing/src/default.env
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/default.env	(revision 749)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/default.env	(revision 811)
@@ -1,3 +1,3 @@
-#############################################################################
+############################################################################
 # ERS default configuration file
 # Jiri Bittner 2003
@@ -14,6 +14,13 @@
 #filename ../data/atlanta/atlanta2.x3d
 #filename ../data/soda/soda.dat
-#filename ../data/soda/soda5.dat
-filename ../data/PowerPlant/ppsection1/part_a/g0.ply
+filename ../data/soda/soda5.dat
+#filename ../data/PowerPlant/ppsection1/part_a/g0.ply
+#filename ../data/PowerPlant/ppsection1/part_b/g0.ply
+#filename ../data/PowerPlant/ppsection1.plb
+#filename ../data/PowerPlant/all.plb
+#filename ../data/PowerPlant/selection3.plb
+#filename ../data/PowerPlant/section10.plb;../data/PowerPlant/section14.plb
+#filename ../data/PowerPlant/selection.plb
+#filename ../data/PowerPlant/comps/ppsection1/comps.plb
 }
 
@@ -21,15 +28,21 @@
 	# stored sample rays
 	samplesFilename rays.out
-	useGlRenderer true
+	useGlRenderer false
+	useGlDebugger true
 #	type sampling
 #	type vss
-	type rss
+#	type rss
+	type render
 	detectEmptyViewSpace false
-#	pvsRenderErrorSamples 1
-	pvsRenderErrorSamples 1000
-	quitOnFinish true
+	pvsRenderErrorSamples 0
+#	pvsRenderErrorSamples 1000
+	quitOnFinish false
 	computeVisibility true
 }
 
+
+RenderSampler {
+	samples 10000
+}
 
 VssPreprocessor {
@@ -76,9 +89,9 @@
 
 RssPreprocessor {
-	samplesPerPass 500000
+	samplesPerPass 100000
 	initialSamples 500000
-	vssSamples 30000000
-	vssSamplesPerPass 1000000
-	useImportanceSampling false
+	vssSamples 1000000000
+	vssSamplesPerPass 100000
+	useImportanceSampling true
 
 	directionalSampling false
@@ -88,6 +101,6 @@
 		pvs false
 		rssTree false
-		rays false
-		numRays 5000
+		rays true
+		numRays 20000
 	}
 
@@ -141,10 +154,11 @@
 
 KdTree {
-	sahUseFaces true
+	sahUseFaces false
 	Termination {
 		minCost 1
-		maxDepth 18
-		maxCostRatio 0.9
+		maxDepth 30
+		maxCostRatio 1.0
 		ct_div_ci 0.5
+		maxNodes 500000	
 	}
 
@@ -156,5 +170,5 @@
 MeshKdTree {
 	Termination {
-		minCost 1
+		minCost 8
 		maxDepth 18
 		maxCostRatio 0.9
@@ -178,5 +192,5 @@
 	Construction {
 		samples 100000
-		samplesPerPass 200000
+		samplesPerPass 100000
 	}
 
@@ -224,5 +238,5 @@
 		refine false
 		compress false
-		merge true
+		merge false
 	}
 
@@ -234,5 +248,5 @@
 		#colorCode MergedTreeDiff
 		colorCode Random
-		exportRays false
+		exportRays true
 		exportGeometry false
 		exportMergedViewCells false
@@ -257,9 +271,10 @@
 #	filename ../scripts/viewcells_atlanta.xml
 #	filename ../scripts/viewcells_soda5-2.xml
-	filename ../data/soda/soda5-viewcells.xml
+#	filename ../data/soda/soda5-viewcells.xml
 #	filename ../scripts/viewcells_atlanta.xml
-#	filename ../data/soda/soda5-viewcells2.xml
+	filename ../data/soda/soda5-viewcells2.xml
 #	filename ../data/atlanta/viewcells_atlanta3.xml
 #	filename ../data/vienna/viewcells_vienna.xml
+#	filename ../data/PowerPlant/power_plant_viewcells_all3.xml
 }
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.h	(revision 746)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.h	(revision 811)
@@ -51,4 +51,20 @@
 };
 
+struct RenderCostSample {
+
+  RenderCostSample() {}
+
+  void Reset() {
+	mVisibleObjects = 0;
+	mVisiblePixels = 0;
+  }
+  
+  // visible object from the given point
+  int mVisibleObjects;
+
+  // visible pixels
+  int mVisiblePixels;
+  
+};
 
 /** Class encapsulating gl rendering for the scene.
@@ -75,6 +91,9 @@
   bool mWireFrame;
   
-bool mDetectEmptyViewSpace;
+  bool mDetectEmptyViewSpace;
   bool mSnapErrorFrames;
+
+  bool mUseGlLists;
+  
   QString mSnapPrefix;
 
@@ -83,4 +102,5 @@
   QWaitCondition mRenderingFinished;
   
+  vector<unsigned int> mOcclusionQueries;
   
   GlRenderer(SceneGraph *sceneGraph,
@@ -102,7 +122,10 @@
   RenderScene();
 
+  void
+  _RenderScene();
+
 
   virtual void
-  SetupProjection(const int w, const int h);
+  SetupProjection(const int w, const int h, const float angle = 70.0f);
 
   
@@ -122,11 +145,23 @@
 Q_OBJECT
 public:
-	GlRendererBuffer(const int w,
-					 const int h,
-					 SceneGraph *sceneGraph,
-					 ViewCellsManager *viewcells,
-					 KdTree *tree);
-
-  
+GlRendererBuffer(const int w,
+				 const int h,
+				 SceneGraph *sceneGraph,
+				 ViewCellsManager *viewcells,
+				 KdTree *tree);
+
+
+  void
+  EvalRenderCostSample(
+					   RenderCostSample &sample
+					   );
+
+  void
+  SampleRenderCost(
+				   const int n,
+				   vector<RenderCostSample> &samples
+				   );
+
+
   void
   EvalPvsStat();
@@ -184,5 +219,6 @@
 
 private:
-	
+  unsigned int *mPixelBuffer;
+  
 	static void GenQueries(const int numQueries);
 	
Index: GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro	(revision 749)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro	(revision 811)
@@ -47,4 +47,4 @@
 ViewCellsManager.cpp VspBspTree.cpp GlRenderer.cpp \
 PreprocessorThread.cpp Renderer.cpp Beam.cpp ViewCellsParser.cpp Tetrahedron3.cpp \
-VrmlExporter.cpp PlyParser.cpp plyfile.c
+VrmlExporter.cpp PlyParser.cpp plyfile.c RenderSampler.cpp
 
